Attribute VB_Name = "Construye"
Option Explicit

Sub ConstruyeSuperficie()   'build surface
    Dim x1 As Single, y1 As Single, z1 As Single
    Dim x2 As Single, y2 As Single, z2 As Single
    Dim x3 As Single, y3 As Single, z3 As Single
    Dim x4 As Single, y4 As Single, z4 As Single
    Dim i As Integer, j As Integer

    If (m_superf > 0) Then glDeleteLists m_superf, 1
    m_superf = glGenLists(1)
    glNewList m_superf, GL_COMPILE_AND_EXECUTE
    glPushMatrix
        For i = 0 To m - 1
            For j = 0 To n - 1
                x1 = xmat(i, j)
                y1 = ymat(i, j)
                z1 = zmat(i, j)

                x2 = xmat(i + 1, j)
                y2 = ymat(i + 1, j)
                z2 = zmat(i + 1, j)

                x3 = xmat(i + 1, j + 1)
                y3 = ymat(i + 1, j + 1)
                z3 = zmat(i + 1, j + 1)

                x4 = xmat(i, j + 1)
                y4 = ymat(i, j + 1)
                z4 = zmat(i, j + 1)
                
                If (tipotex) Then
                    LuzDifusa1(0) = xcol(i, j)
                    LuzDifusa1(1) = ycol(i, j)
                    LuzDifusa1(2) = zcol(i, j)

                    LuzDifusa2(0) = xcol(i, j)
                    LuzDifusa2(1) = ycol(i, j)
                    LuzDifusa2(2) = zcol(i, j)

                    LuzDifusa3(0) = xcol(i, j)
                    LuzDifusa3(1) = ycol(i, j)
                    LuzDifusa3(2) = zcol(i, j)
                End If
                
                If (frmMain.Mreverse.Checked) Then
                    Call RenderTriangulo(x4, y4, z4, x2, y2, z2, x1, y1, z1)
                    Call RenderTriangulo(x3, y3, z3, x2, y2, z2, x4, y4, z4)
                Else
                    Call RenderTriangulo(x1, y1, z1, x2, y2, z2, x4, y4, z4)
                    Call RenderTriangulo(x4, y4, z4, x2, y2, z2, x3, y3, z3)
                End If
            Next
        Next
    glPopMatrix
    glEndList
End Sub

Sub ConstruyeEsfera()   'build spheres
    Dim x1 As Single, y1 As Single, z1 As Single
    Dim i As Integer, j As Integer

    If (m_esfera > 0) Then glDeleteLists m_esfera, 1
    m_esfera = glGenLists(1)
    glNewList m_esfera, GL_COMPILE_AND_EXECUTE
    glPushMatrix
    For i = 0 To m
        For j = 0 To n
            x1 = xmat(i, j)
            y1 = ymat(i, j)
            z1 = zmat(i, j)

            LuzDifusa1(0) = xcol(i, j)
            LuzDifusa1(1) = ycol(i, j)
            LuzDifusa1(2) = zcol(i, j)

            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzDifusa1(0)
            glPushMatrix
                glTranslatef x1, y1, z1
                glutSolidSphere TamEsfe * 2, 10, 10
            glPopMatrix
        Next
    Next
    glPopMatrix
    glEndList
End Sub

Sub ConstruyeLinea()    'build lines
    Dim i As Integer, j As Integer
    Dim x1 As Single, y1 As Single, z1 As Single
    Dim x2 As Single, y2 As Single, z2 As Single
    Dim x3 As Single, y3 As Single, z3 As Single
    Dim x4 As Single, y4 As Single, z4 As Single

    If (m_lineas > 0) Then glDeleteLists m_lineas, 1
    m_lineas = glGenLists(1)
    glNewList m_lineas, GL_COMPILE_AND_EXECUTE
        glPushMatrix
            glLineWidth 1.6
            LuzDifusaX(0) = 1 'Rnd(Timer)
            LuzDifusaX(1) = 1 'Rnd(Timer)
            LuzDifusaX(2) = 1 'Rnd(Timer)
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzDifusaX(0)

            For i = 0 To m - 1
                For j = 0 To n - 1
                    x1 = xmat(i, j)
                    y1 = ymat(i, j)
                    z1 = zmat(i, j)

                    x2 = xmat(i + 1, j)
                    y2 = ymat(i + 1, j)
                    z2 = zmat(i + 1, j)

                    x3 = xmat(i + 1, j + 1)
                    y3 = ymat(i + 1, j + 1)
                    z3 = zmat(i + 1, j + 1)

                    x4 = xmat(i, j + 1)
                    y4 = ymat(i, j + 1)
                    z4 = zmat(i, j + 1)
    
                    glBegin GL_LINE_STRIP
                        glVertex3f x1, y1, z1
                        glVertex3f x4, y4, z4
                        glVertex3f x3, y3, z3
                        glVertex3f x2, y2, z2
                        glVertex3f x1, y1, z1
                    glEnd
                Next
            Next
        glPopMatrix
    glEndList
End Sub

Sub ConstruyeEjes() 'build axis
    Dim te As GLfloat, tc As GLfloat, TT As GLfloat, dt As GLfloat, LuzEjes(3) As GLfloat
    
    te = 0.5
    tc = 0.2
    TT = 0.2
    dt = 0.5
    
    If (m_ejes > 0) Then glDeleteLists m_ejes, 1
    m_ejes = glGenLists(1)
    glNewList m_ejes, GL_COMPILE_AND_EXECUTE
        glPushMatrix
            glLineWidth 3
            LuzEjes(0) = 0
            LuzEjes(1) = 0
            LuzEjes(2) = 1
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzEjes(0)
            glBegin GL_LINES
                glVertex3f -(maxAX + te), origenY, origenZ
                glVertex3f maxAX + te, origenY, origenZ
            glEnd
        glPopMatrix

        glPushMatrix 'X1 - from
            glTranslatef maxAX + te, origenY, origenZ
            glRotatef 90, 0, 90, 0
            glutSolidCone tc, 0.3, 3, 5
        glPopMatrix

        glPushMatrix 'X2 to
            glTranslatef -(maxAX + te), origenY, origenZ
            glRotatef 90, 0, -90, 0
            glutSolidCone tc, 0.3, 3, 5
        glPopMatrix

        glPushMatrix 'char X
            glTranslatef maxAX + te + dt, origenY, origenZ
            glBegin GL_LINES
                glVertex3f -TT, -TT, 0
                glVertex3f TT, TT, 0
                glVertex3f -TT, TT, 0
                glVertex3f TT, -TT, 0
            glEnd
        glPopMatrix
        
        '----------------------------------
        glPushMatrix
            LuzEjes(0) = 0
            LuzEjes(1) = 1
            LuzEjes(2) = 0
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzEjes(0)
            glBegin GL_LINES
                glVertex3f origenX, -(maxAY + te), origenZ
                glVertex3f origenX, maxAY + te, origenZ
            glEnd
        glPopMatrix

        glPushMatrix 'Y1 - from
            glTranslatef origenX, maxAY + te, origenZ
            glRotatef 90, -90, 0, 0
            glutSolidCone tc, 0.3, 4, 5
        glPopMatrix

        glPushMatrix 'Y2 - to
            glTranslatef origenX, -(maxAY + te), origenZ
            glRotatef 90, 90, 0, 0
            glutSolidCone tc, 0.3, 4, 5
        glPopMatrix

        glPushMatrix 'char Y
            glTranslatef origenX, maxAY + te + dt, origenZ
            glBegin GL_LINES
                glVertex3f TT, TT, 0
                glVertex3f 0, 0, 0
                glVertex3f -TT, TT, 0
                glVertex3f 0, 0, 0
                glVertex3f 0, 0, 0
                glVertex3f 0, -TT, 0
            glEnd
        glPopMatrix

        '-----------------------------------------
        glPushMatrix
            LuzEjes(0) = 1
            LuzEjes(1) = 0
            LuzEjes(2) = 0
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzEjes(0)
            glBegin GL_LINES
                glVertex3f origenX, origenY, -(maxAZ + te)
                glVertex3f origenX, origenY, maxAZ + te
            glEnd
        glPopMatrix

        glPushMatrix 'Z1 - from
            glTranslatef origenX, origenY, maxAZ + te
            glRotatef 0, 0, -90, 0
            glutSolidCone tc, 0.3, 5, 5
        glPopMatrix

        glPushMatrix 'Z2 - to
            glTranslatef origenX, origenY, -(maxAZ + te)
            glRotatef 180, 0, -90, 0
            glutSolidCone tc, 0.3, 5, 5
        glPopMatrix

        glPushMatrix 'char Z
            glTranslatef origenX, origenY, maxAZ + te + dt
            glBegin GL_LINES
                glVertex3f -TT, TT, 0
                glVertex3f TT, TT, 0
                glVertex3f TT, TT, 0
                glVertex3f -TT, -TT, 0
                glVertex3f TT, -TT, 0
                glVertex3f -TT, -TT, 0
            glEnd
        glPopMatrix
    glEndList
End Sub

Sub ConstruyeReticula() 'buld grid
    Dim i As Integer, j As Integer
    Dim x1 As Single, y1 As Single, z1 As Single
    Dim x2 As Single, y2 As Single, z2 As Single
    Dim x3 As Single, y3 As Single, z3 As Single
    Dim x4 As Single, y4 As Single, z4 As Single
    Dim LuzReti(3) As GLfloat
    If (m_reti > 0) Then glDeleteLists m_reti, 1
    m_reti = glGenLists(1)
    glNewList m_reti, GL_COMPILE_AND_EXECUTE
        glPushMatrix
            glLineWidth 1.6
            LuzReti(0) = (LuzDifusa1(0) + LuzDifusa2(0) + LuzDifusa3(0)) / 3#
            LuzReti(1) = (LuzDifusa1(1) + LuzDifusa2(1) + LuzDifusa3(1)) / 3#
            LuzReti(2) = (LuzDifusa1(2) + LuzDifusa2(2) + LuzDifusa3(2)) / 3#
            LuzReti(3) = 0
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzReti(0)
            For i = 0 To m - 1
                For j = 0 To n - 1
                    x1 = xmat(i, j)
                    y1 = ymat(i, j)
                    z1 = zmat(i, j)

                    x2 = xmat(i + 1, j)
                    y2 = ymat(i + 1, j)
                    z2 = zmat(i + 1, j)

                    x3 = xmat(i + 1, j + 1)
                    y3 = ymat(i + 1, j + 1)
                    z3 = zmat(i + 1, j + 1)

                    x4 = xmat(i, j + 1)
                    y4 = ymat(i, j + 1)
                    z4 = zmat(i, j + 1)

                    glBegin GL_LINE_STRIP
                        glVertex3f x1, y1, z1
                        glVertex3f x4, y4, z4
                        glVertex3f x3, y3, z3
                        glVertex3f x2, y2, z2
                        glVertex3f x1, y1, z1
                    glEnd
                Next
            Next
        glPopMatrix
    glEndList
End Sub

Sub ConstruyeCubo() 'build frame
    Dim LuzCubo(3) As GLfloat
    If (m_cubo > 0) Then glDeleteLists m_cubo, 1
    m_cubo = glGenLists(1)
    glNewList m_cubo, GL_COMPILE_AND_EXECUTE
        glPushMatrix
            glLineWidth 1.6
            LuzCubo(0) = 1
            LuzCubo(1) = 1
            LuzCubo(2) = 1
            LuzCubo(3) = 0
            glMaterialfv GL_FRONT, GL_AMBIENT_AND_DIFFUSE, LuzCubo(0)
            glBegin GL_LINE_STRIP
                glVertex3f -maxAX, -maxAY, -maxAZ
                glVertex3f -maxAX, maxAY, -maxAZ
                glVertex3f maxAX, maxAY, -maxAZ
                glVertex3f maxAX, -maxAY, -maxAZ
                glVertex3f -maxAX, -maxAY, -maxAZ
            glEnd
            glBegin GL_LINE_STRIP
                glVertex3f -maxAX, -maxAY, maxAZ
                glVertex3f -maxAX, maxAY, maxAZ
                glVertex3f maxAX, maxAY, maxAZ
                glVertex3f maxAX, -maxAY, maxAZ
                glVertex3f -maxAX, -maxAY, maxAZ
            glEnd
            glBegin GL_LINES
                glVertex3f -maxAX, -maxAY, -maxAZ
                glVertex3f -maxAX, -maxAY, maxAZ
                glVertex3f -maxAX, maxAY, -maxAZ
                glVertex3f -maxAX, maxAY, maxAZ
                glVertex3f maxAX, maxAY, -maxAZ
                glVertex3f maxAX, maxAY, maxAZ
                glVertex3f maxAX, -maxAY, -maxAZ
                glVertex3f maxAX, -maxAY, maxAZ
            glEnd
        glPopMatrix
    glEndList
End Sub
