Attribute VB_Name = "Guardar"
Option Explicit

Public Function GuardaImagen(FileName As String, ByVal w As Long, ByVal h As Long) As Boolean
    Dim infoHeader As BITMAPINFOHEADER
    Dim fileHeader As BITMAPFILEHEADER
    Dim i As Long, temp As Byte, pixels() As Byte
    Dim viewport(0 To 3) As Long, pad As Long, Width As Long
    On Error GoTo ErrorDetected

    w = w + 1
    glGetIntegerv GL_VIEWPORT, viewport(0)    'check range
    Width = w * 3    'save as 24bit bmp, 3 bytes per color
    
    'align to 4 bytes
    pad = Width Mod 4
    If pad Then pad = 4 - pad
    Width = Width + pad
    ReDim pixels(0 To Width * h - 1)

    'Read the pixels
    glPixelStorei GL_UNPACK_ALIGNMENT, 4  ' Force 4-byte alignment
    glPixelStorei GL_UNPACK_SKIP_ROWS, 0
    glPixelStorei GL_UNPACK_SKIP_PIXELS, 0
    glPixelStorei GL_UNPACK_ROW_LENGTH, 0 'full image
    glReadPixels 0, 0, w, h, GL_RGB, GL_UNSIGNED_BYTE, pixels(0)

    'set the pixel data in the pic
    infoHeader.biSize = Len(infoHeader)
    infoHeader.biPlanes = 1
    infoHeader.biBitCount = 24
    infoHeader.biCompression = BI_RGB
    infoHeader.biSizeImage = Width * Abs(h)
    infoHeader.biXPelsPerMeter = 0
    infoHeader.biYPelsPerMeter = 0
    infoHeader.biClrUsed = 0
    infoHeader.biClrImportant = 0
    infoHeader.biWidth = w
    infoHeader.biHeight = h

    'Define BMP header
    fileHeader.bfSize = Len(fileHeader)
    fileHeader.bfType = &H4D42
    fileHeader.bfReserved1 = 0
    fileHeader.bfReserved2 = 0
    fileHeader.bfOffBits = Len(fileHeader) + Len(infoHeader)

    'Swap red and blue for the bitmap...
    For i = 0 To infoHeader.biSizeImage - 1 Step 3
        temp = pixels(i)
        pixels(i) = pixels(i + 2)
        pixels(i + 2) = temp
    Next
    
    If (Len(Dir(FileName)) > 0) Then Kill FileName
    Open FileName For Binary As #1
    Put #1, , fileHeader
    Put #1, , infoHeader
    Put #1, , pixels
    Close #1
ErrorDetected:
End Function
