Attribute VB_Name = "calcmat"
Option Explicit

Function f1(u As Single, v As Single)
    f1 = Cos(u) * Cos(v)
End Function

Function f2(u As Single, v As Single)
    f2 = Cos(u) * Sin(v)
End Function

Function f3(u As Single, v As Single)
    f3 = Sin(u)
End Function

Sub GenMatriz()
    Dim i As Integer, j As Integer, v As Single, u As Single
    Dim xmin As Single, ymin As Single, zmin As Single
    Dim xmax As Single, ymax As Single, zmax As Single
    Dim xcal As Single, ycal As Single, zcal As Single
    Dim xpen As Single, ypen As Single, zpen As Single
    Dim xint As Single, yint As Single, zint As Single

    On Error Resume Next

    xmin = 1E+20
    xmax = -xmin
    ymin = 1E+20
    ymax = -ymin
    zmin = 1E+20
    zmax = -zmin

    uinc = (umax - umin) / m    'delta u
    vinc = (vmax - vmin) / n    'delta v

    u = umin
    For i = 0 To m
        v = vmin
        For j = 0 To n
            '1st function for X plane <<<<<<<<<<<<<<<<<<<<<<
            xcal = f1(u, v)
            If (xcal < xmin) Then xmin = xcal
            If (xcal > xmax) Then xmax = xcal
            xmah(i, j) = xcal
            
            '2nd function for Y plane <<<<<<<<<<<<<<<<<<<<<<
            ycal = f2(u, v)
            If (ycal < ymin) Then ymin = ycal
            If (ycal > ymax) Then ymax = ycal
            ymah(i, j) = ycal
            
            '3rd function for Z plane <<<<<<<<<<<<<<<<<<<<<<
            zcal = f3(u, v)
            If (zcal < zmin) Then zmin = zcal
            If (zcal > zmax) Then zmax = zcal
            zmah(i, j) = zcal
            
            v = v + vinc    'v-deltav
        Next
        u = u + uinc    'u-deltau
    Next
    
    If (xmin <> xmax And ymin <> ymax And zmin <> zmax) Then
        maxAX = 6   '
        maxAY = 6   '
        maxAZ = 6   '

        minAX = -maxAX
        minAY = -maxAY
        minAZ = -maxAZ

        xpen = (maxAX - minAX) / (xmax - xmin)
        xint = maxAX - xpen * xmax

        ypen = (maxAY - minAY) / (ymax - ymin)
        yint = maxAY - ypen * ymax

        zpen = (maxAZ - minAZ) / (zmax - zmin)
        zint = maxAZ - zpen * zmax
        For i = 0 To m
            For j = 0 To n
                xmat(i, j) = xmah(i, j) * xpen + xint
                ymat(i, j) = ymah(i, j) * ypen + yint
                zmat(i, j) = zmah(i, j) * zpen + zint
            Next
        Next
        origenX = ((xmax + xmin) / 2#) * xpen + xint
        origenY = ((ymax + ymin) / 2#) * ypen + yint
        origenZ = ((zmax + zmin) / 2#) * zpen + zint
    Else
        MsgBox "Errors detected calculating, check your functions and limits", vbCritical, "MESSAGE"
    End If
End Sub

Sub GenEfectos(efecto As Integer)
    Dim i As Integer, j As Integer
    Dim Rdelta, Gdelta, Bdelta, Rfixed, Gfixed, Bfixed, colorA As Long, colorN As Long
    Dim rg1, gg1, bg1, rg2, gg2, bg2, rt1, rt2, gt1, gt2, bt1, bt2, rf1, rf2, gf1, gf2, bf1, bf2
    Dim r1, g1, b1, r2, g2, b2, r3, g3, b3
    
    Call reduce(m_color1gra, rg1, gg1, bg1)     'gradient
    Call reduce(m_color2gra, rg2, gg2, bg2)
    
    Call reduce(m_color1tab, rt1, gt1, bt1)     'checkboard
    Call reduce(m_color2tab, rt2, gt2, bt2)
    
    Call reduce(m_color1fra, rf1, gf1, bf1)     'strips
    Call reduce(m_color2fra, rf2, gf2, bf2)

    Randomize
    If (efecto = 1) Then
        colorA = frmMain.Picture1.BackColor
        frmMain.CommonDialog1.flags = 3
        frmMain.CommonDialog1.Color = colorA
        frmMain.CommonDialog1.ShowColor
        colorN = frmMain.CommonDialog1.Color
        Call reduce(colorN, Rfixed, Gfixed, Bfixed)
    End If
    
    If (efecto <> 8) Then
        tipotex = True
        Rdelta = -(rg1 - rg2) / m
        Gdelta = -(gg1 - gg2) / m
        Bdelta = -(bg1 - bg2) / m

        For i = 0 To m
            rg1 = Abs(rg1 + Rdelta)
            gg1 = Abs(gg1 + Gdelta)
            bg1 = Abs(bg1 + Bdelta)
            For j = 0 To n
                Select Case efecto
                    Case 1: 'fixed color
                        xcol(i, j) = Rfixed
                        ycol(i, j) = Gfixed
                        zcol(i, j) = Bfixed
    
                    Case 2: 'random color
                        xcol(i, j) = Rnd(Timer)
                        ycol(i, j) = Rnd(Timer)
                        zcol(i, j) = Rnd(Timer)
    
                    Case 3: 'checkboard
                        If ((i Mod 2) + (j Mod 2) = 1) Then
                            xcol(i, j) = rt1    'red-checkboard color 1
                            ycol(i, j) = gt1    'green-checkboard color 1
                            zcol(i, j) = bt1    'blue-checkboard color 1
                        Else
                            xcol(i, j) = rt2    'red-checkboard color 2
                            ycol(i, j) = gt2    'green-checkboard color 2
                            zcol(i, j) = bt2    'blue-checkboard color 2
                        End If
    
                    Case 4: 'strips over x
                        If (i Mod 2 = 0) Then
                            xcol(i, j) = rf1    'red-strips color 1
                            ycol(i, j) = gf1    'green-strips color 1
                            zcol(i, j) = bf1    'blue-strips color 1
                        Else
                            xcol(i, j) = rf2    'red-strips color 2
                            ycol(i, j) = gf2    'green-strips color 2
                            zcol(i, j) = bf2    'blue-strips color 2
                        End If
    
                    Case 5: 'strips over z
                        If (j Mod 2 = 0) Then
                            xcol(i, j) = rf1    'red-strips color 1
                            ycol(i, j) = gf1    'green-strips color 1
                            zcol(i, j) = bf1    'blue-strips color 1
                        Else
                            xcol(i, j) = rf2    'red-strips color 2
                            ycol(i, j) = gf2    'green-strips color 2
                            zcol(i, j) = bf2    'blue-strips color 2
                        End If
    
                    Case 6: 'gradient over x
                        xcol(j, i) = rg1    'red-gradient
                        ycol(j, i) = gg1    'green-gradient
                        zcol(j, i) = bg1    'blue-gradient
                    
                    Case 7: 'gradient over z
                        xcol(i, j) = rg1    'red-gradient
                        ycol(i, j) = gg1    'green-gradient
                        zcol(i, j) = bg1    'blue-gradient
                End Select
            Next
        Next
    Else
        tipotex = False
        LuzDifusa1(0) = Rnd
        LuzDifusa1(1) = Rnd
        LuzDifusa1(2) = Rnd
        LuzDifusa1(3) = 1
        
        LuzDifusa2(0) = Rnd
        LuzDifusa2(1) = Rnd
        LuzDifusa2(2) = Rnd
        LuzDifusa2(3) = 1
        
        LuzDifusa3(0) = Rnd
        LuzDifusa3(1) = Rnd
        LuzDifusa3(2) = Rnd
        LuzDifusa3(3) = 1
    End If
End Sub

Sub reduce(ColorPar, R, G, B)
    Dim temp
    temp = ColorPar
    B = Int(temp / 65536)
    temp = temp - (B * 65536)
    G = Int(temp / 256)
    temp = temp - (G * 256)
    R = temp / 255
    G = G / 255
    B = B / 255
End Sub
